enum Gender {
    // コンストラクタを使うenum定数
    MAN("Man", 0),
    WOMAN("Woman", 1),
    OTHER("Other", 2); // 後続がある場合はセミコロン文字で終端する

    // 任意のフィールド変数を追加可能。アクセス制御修飾子は通常のクラスのフィールドと同じ意味
    private final String nameForDisp;
    private final int valueForDb;

    Gender(String nameForDisp, int valueForDb) { // コンストラクタ（注5）
        this.nameForDisp = nameForDisp;
        this.valueForDb = valueForDb;
    }
    // 必要に応じてtoStringメソッドをオーバーライドするのがenum型の定石
    public String toString() {
        return this.nameForDisp;
    }
    // 任意のメソッドを追加可能
    public int toDatabaseValue() {
        return this.valueForDb;
    }

    // サンプルコード以外ではあまりしませんがmainメソッドも普通に持てます
    public static void main(String... args) {
        System.out.println(MAN); //=> "Man" 暗黙にtoStringメソッド呼び出しになるので
        System.out.println(MAN.toDatabaseValue()); //=> "0"
    }
}
