import java.io.*;
import java.nio.file.*;
import java.util.stream.*;

public class Main {
    public static void main(String... args) {
        if (args.length <= 0) {
            System.out.println("コマンドライン引数でファイル名を指定してください");
            System.exit(0);
        }

        try {
            Path file = Paths.get(args[0]); // 指定ファイル
            Stream<String> lines = Files.lines(file); // ファイルの1行ごとのStream
            lines.forEach(System.out::println);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
