import java.io.*;
import java.net.*;

public class MyClient {
    private static final String SERVER_HOST = "localhost"; // 同一PC上にサーバプロセスがいる前提
    private static final int SERVER_PORT = 9000; // サーバ側のポート番号（サーバと事前取り決め）

    public static void main(String... args) {
        if (args.length < 1) {
            System.err.println("usage: java " + MyClient.class.getSimpleName() + " 送信文字列");
            System.exit(-1);
        }
        try (Socket sock = new Socket(SERVER_HOST, SERVER_PORT);  // 能動的ソケット（接続確立まで待機）
             Reader in = new BufferedReader(new InputStreamReader(sock.getInputStream()));
             Writer out = new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()))) {
            for (String arg : args) {
                out.write(arg);
            }
            out.write('.'); // 終端文字列（サーバと事前取り決め）
            out.flush();

            char[] buf = new char[4096];
            while (in.read(buf) != -1) {
                System.out.print(buf);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
