import java.io.*;
import java.net.*;

public class MyClientTimeout {
    private static final String SERVER_HOST = "localhost"; // 同一PC上にサーバプロセスがいる前提
    private static final int SERVER_PORT = 9000; // サーバ側のポート番号（サーバと事前取り決め）
    private static final char END_MARK = '.'; // 終端文字列（サーバとの事前取り決め）
    private static final int CONNECT_TIMEOUT = 5000; // 単位はミリ秒
    private static final int READ_TIMEOUT = 5000;    // 単位はミリ秒

    public static void main(String... args) {
        if (args.length < 1) {
            System.err.println("usage: java " + MyClientTimeout.class.getSimpleName() + " 送信文字列");
            System.exit(-1);
        }
        try (Socket sock = new Socket()) { // 能動的ソケットの生成（未接続）
            sock.connect(new InetSocketAddress(SERVER_HOST, SERVER_PORT), CONNECT_TIMEOUT);
            sock.setSoTimeout(READ_TIMEOUT);
            try (Reader in = new BufferedReader(new InputStreamReader(sock.getInputStream()));
                 Writer out = new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()))) {
                for (String arg : args) {
                    out.write(arg);
                }
                out.write('.'); // 終端文字列（サーバと事前取り決め）
                out.flush();
                
                char[] buf = new char[4096];
                while (in.read(buf) != -1) {
                    System.out.print(buf);
                }
            }
        } catch (SocketTimeoutException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
