import java.io.*;
import java.net.*;

public class MyServerTimeout {
    private static final int LISTEN_PORT = 9000; // 待ち受けポート番号（クライアントと事前取り決め）
    private static final char END_MARK = '.'; // 終端文字列（クライアントとの事前取り決め）
    private static final int ACCEPT_TIMEOUT = 5000; // 単位はミリ秒
    private static final int READ_TIMEOUT = 5000;   // 単位はミリ秒

    public static void main(String... args) {
        try (ServerSocket ssock = new ServerSocket(LISTEN_PORT)) { // 待ち受けソケット（受動的ソケット）
            ssock.setSoTimeout(ACCEPT_TIMEOUT);
            try (Socket sock = ssock.accept()) {  // 受け入れソケット
                sock.setSoTimeout(READ_TIMEOUT);
                try (Reader in = new BufferedReader(new InputStreamReader(sock.getInputStream()));
                     Writer out = new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()))) {
                    StringBuilder sb = new StringBuilder(4096);
                    int c;
                    while ((c = in.read()) != -1) {
                        if (c == END_MARK) {
                            break;
                        }
                        sb.append((char)c);
                    }
                    out.write(sb.toString().toUpperCase()); // 受信文字列を大文字にして送信
                    out.flush();
                    
                    System.out.println(sb);
                }
            }
        } catch (SocketTimeoutException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
