import java.io.*;

public class FileByte {
    public static void main(String... args) {
        if (args.length < 1) {
            System.err.println("コマンドライン引数でファイル名を指定してください");
            System.exit(-1);
        }
        try (InputStream in = new FileInputStream(args[0])) { // FileInputStreamクラスはInputStreamを継承したクラス
            byte[] buf = new byte[4096]; // ファイル読み書きは4キロバイト以上の単位で行うのが定石
            int len;

            while ((len = in.read(buf)) != -1) { // ファイルの終端に達するまで読み続ける
                System.out.write(buf, 0, len);   // 読んだバイト列を標準出力へ表示
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
