import java.io.*;

public class FileChar {
    public static void main(String... args) {
        if (args.length < 1) {
            System.err.println("コマンドライン引数でファイル名を指定してください");
            System.exit(-1);
        }
        try (Reader in = new FileReader(args[0]); // FileReaderクラスはReaderを継承したクラス
             Writer out = new OutputStreamWriter(System.out)) {
            char[] buf = new char[4096];
            int len;

            while ((len = in.read(buf)) != -1) {
                out.write(buf, 0, len);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
