import java.util.*;
import java.util.concurrent.*;

public class MyDeadLock {
    private static final int NUM_LOOP = 100000; // デッドロックが起きない場合は数値を大きくしてください

    public void exec() {
        try {
            // 共有データ
            List<String> list1 = Arrays.asList("one", "two", "three");
            List<String> list2 = Arrays.asList("ONE", "TWO", "THREE");

            ExecutorService executor = Executors.newFixedThreadPool(8);

            Future<?> t1 = executor.submit(() -> { // list1、list2の順序でモニタロックを獲得
                    for (int i = 0; i < NUM_LOOP; i++) {
                        synchronized(list1) {
                            Collections.sort(list1);
                            synchronized(list2) {
                                Collections.sort(list2);
                            }
                        }
                    }
            });

            Future<?> t2 = executor.submit(() -> { // list2、list1の順序でモニタロックを獲得
                    for (int i = 0; i < NUM_LOOP; i++) {
                        synchronized(list2) {
                            Collections.sort(list2);
                            synchronized(list1) {
                                Collections.sort(list1);
                            }
                        }
                    }
            });

            t1.get();
            t2.get();
            executor.shutdown();

            System.out.println("finished");
        } catch (InterruptedException | ExecutionException e) {
            e.printStackTrace();
        }
    }

    public static void main(String... args) {
        MyDeadLock my = new MyDeadLock();
        my.exec();
    }
}
