import java.util.concurrent.*;

public class MyExecute {
    private static class Worker implements Runnable {
        private final String name; // サブスレッド識別用の文字列

        Worker(String name) {
            this.name = name;
        }

        @Override
        public void run() { // サブスレッドのエントリポイント
            for (int i = 0; i < 256; i++) {
                System.out.println(name + " " + i);
            }
        }
    }

    public static void main(String... args) throws InterruptedException {
        ExecutorService executor = Executors.newFixedThreadPool(8);

        executor.execute(new Worker("one"));
        executor.execute(new Worker("two"));

        for (int i = 0; i < 256; i++) {
            System.out.println("main " + i);
        }
        executor.shutdown();
        executor.awaitTermination(10, TimeUnit.SECONDS); // サブスレッド終了を待機（引数でタイムアウト値を指定（10秒間））
    }
}
