import java.util.concurrent.*;

public class MyCallable {
    private static class Worker implements Callable<Integer> {
        private final String name; // サブスレッド識別用の文字列

        Worker(String name) {
            this.name = name;
        }

        @Override
        public Integer call() throws Exception { // サブスレッドのエントリポイント
            int sum = 0;
            for (int i = 0; i < 256; i++) {
                System.out.println(name + " " + i);
                sum += i;
            }
            return sum; // サブスレッドの返り値
        }
    }

    public static void main(String... args) throws InterruptedException, ExecutionException {
        ExecutorService executor = Executors.newFixedThreadPool(8);

        Future<Integer> ret1 = executor.submit(new Worker("one"));
        Future<Integer> ret2 = executor.submit(new Worker("two"));

        for (int i = 0; i < 256; i++) {
            System.out.println("main " + i);
        }
        // Futureオブジェクトのgetメソッドでサブスレッドの返り値を取得
        // サブスレッド実行中はgetメソッドは待機（待機のタイムアウト指定可能）
        System.out.println(ret1.get());
        System.out.println(ret2.get());
        executor.shutdown();
    }
}
