import java.lang.reflect.*;

public class MyReflect {
    public static void main(String... args) {
        try {
            // Class型の変数名には伝統的にclazzをよく使います
            // classは予約語なので変数名に使えないからです
            Class<StringBuilder> clazz1 = StringBuilder.class;

            StringBuilder sb = new StringBuilder();
            Class<? extends StringBuilder> clazz2 = sb.getClass();

            Class<?> clazz3 = Class.forName("java.lang.StringBuilder");

            // 同じオブジェクトなのでSystem.identityHashCodeが同じ値になります
            System.out.println(System.identityHashCode(clazz1) + ", "
                + System.identityHashCode(clazz2) + ", " + System.identityHashCode(clazz3));

        // リフレクションを使うコードの例外:
        // Java7以降はReflectiveOperationExceptionが基底例外です
        // Java7より前はClassNotFoundExceptionなど、個別の例外の捕捉が必要です
        } catch (ReflectiveOperationException e) {
            e.printStackTrace();
        }
    }
}
