import java.util.*;
import java.lang.reflect.*;

public class MyDI {
    // クラス、引数型、引数オブジェクト型を文字列で受け取り、オブジェクトを生成する
    public Object resolv(String targetType, String argType, String argObjectType) throws Exception {
        Class<?> targetClass = Class.forName(targetType); // 生成オブジェクトのクラス

        Class<?> argClass = Class.forName(argObjectType); // 引数オブジェクトの型
        Object arg = argClass.newInstance();              // 引数オブジェクト

        Constructor<?> constructor = targetClass.getConstructor(Class.forName(argType));
        return constructor.newInstance(arg);
    }

    public static void main(String... args) throws Exception {
        MyDI my = new MyDI();

        // DIでMyStringListオブジェクト（リスト18.10）を生成
        MyStringList sl = (MyStringList)my.resolv("MyStringList", "java.util.List", "java.util.ArrayList");
        sl.append("one");
        sl.append("two");
        sl.dump();
    }
}
