import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.shape.LineTo;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;
import javafx.scene.shape.Shape;
import javafx.stage.Stage;

public class MyApplication extends Application {
    Shape createArchimedeanSpiral(double centerX, double centerY,
                                  double radius, double angle) {
        Path path = new Path();
        path.getElements().add(new MoveTo(centerX, centerY));
        double thetaInc = Math.toRadians(1);
        double thetaEnd = Math.toRadians(angle);
        double a = radius / thetaEnd;
        for (double theta = 0.0; theta < thetaEnd; theta += thetaInc) {
            double r = a * theta;
            double x = r * Math.cos(theta) + centerX;
            double y = r * Math.sin(theta) + centerY;
            path.getElements().add(new LineTo(x, y));
        }
        return path;
    }
    
    @Override
    public void start(Stage stage) throws Exception {
        Shape spiral = createArchimedeanSpiral(100, 100, 100, 720);
        spiral.setStrokeWidth(2);
        
        Group root = new Group();
        root.getChildren().add(spiral);

        Scene scene = new Scene(root);
        stage.setScene(scene);
        stage.setTitle("Spiral");
        stage.show();
    }
}
