import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage stage) throws Exception {
        Image image = new Image(getClass().getResource("duke.jpg").toExternalForm(),
                true /* load in background */);
        image.progressProperty().addListener(new ChangeListener() {
            @Override
            public void changed(ObservableValue observable, Object oldValue, Object newValue) {
                double progress = (double) newValue;
                if (progress < 1) {
                    System.out.println("loading...");
                } else {
                    System.out.println("loaded.");
                }
            }
        });
        ImageView imageView = new ImageView(image);
        
        StackPane root = new StackPane();
        root.getChildren().addAll(imageView);
        Scene scene = new Scene(root, 200, 200);
        stage.setTitle("Image");
        stage.setScene(scene);
        stage.show();
    }
}
