import javafx.application.Application;
import javafx.geometry.Bounds;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.transform.Affine;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage stage) throws Exception {
        Image image = new Image(getClass().getResource("duke.jpg").toExternalForm());
        ImageView node = new ImageView(image);

        Bounds bounds = node.getBoundsInLocal();
        double x1 = bounds.getMinX() + bounds.getWidth() / 2;
        double y1 = bounds.getMinY() + bounds.getHeight() / 2;
        
        double theta = Math.toRadians(45);
        double cos = Math.cos(theta);
        double sin = Math.sin(theta);
        Affine transform = new Affine(
                cos, -sin, x1 *(1 - cos) + y1 * sin,
                sin,  cos, y1 *(1 - cos) - x1 * sin);
        node.getTransforms().add(transform);

        Group root = new Group();
        root.getChildren().add(node);
        Scene scene = new Scene(root);
        stage.setScene(scene);
        stage.show();
    }
}

