import javafx.application.Application;
import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.input.MouseEvent;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage primaryStage) throws Exception {
        Node node = new Circle(100, 100, 50);
        
        EventHandler<MouseEvent> handler = new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent event) {
                System.out.println("handle " + event);
            }
        };
        node.addEventHandler(MouseEvent.MOUSE_PRESSED, handler);
        node.addEventFilter(MouseEvent.MOUSE_MOVED, handler);

        Scene scene = new Scene(new Group(node), 200, 200);
        primaryStage.setScene(scene);
        primaryStage.setTitle("Event Callback");
        primaryStage.show();
    }
}
