import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;

class MyBean implements Serializable {
    private final PropertyChangeSupport pcs = new PropertyChangeSupport(this);

    public void addWidthListener(PropertyChangeListener listener) {
        pcs.addPropertyChangeListener("width", listener);
    }

    public void addHeightListener(PropertyChangeListener listener) {
        pcs.addPropertyChangeListener("height", listener);
    }

    private int width;
    private int height;

    public int getWidth() {
        return width;
    }

    public void setWidth(int width) {
        int old = this.width;
        this.width = width;
        pcs.firePropertyChange("width", old, width);
    }

    public int getHeight() {
        return height;
    }

    public void setHeight(int height) {
        int old = this.height;
        this.height = height;
        pcs.firePropertyChange("height", old, height);
    }
}
