import javafx.beans.InvalidationListener;
import javafx.beans.Observable;
import javafx.beans.property.ReadOnlyProperty;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;

public class Main {
    public static void main(String...args) {
        InvalidationListener invalidationListener = new InvalidationListener() {
            @Override
            public void invalidated(Observable observable) {
                ReadOnlyProperty property = (ReadOnlyProperty) observable;
                System.out.println(property.getName() + " was invalidated");
            }
        };

        ChangeListener changeListener = new ChangeListener() {
            @Override
            public void changed(ObservableValue observable, Object oldValue, Object newValue) {
                ReadOnlyProperty property = (ReadOnlyProperty) observable;
                System.out.println(property.getName() + " was changed from " +
                        oldValue + " to " + newValue);
            }
        };
        
        MyBean bean = new MyBean();
        
        bean.sizeProperty().addListener(invalidationListener);
        bean.setWidth(10);
        bean.setHeight(20);
        
        bean.sizeProperty().removeListener(invalidationListener);
        
        bean.sizeProperty().addListener(changeListener);
        bean.setWidth(20);
        bean.setWidth(30);
    }
}
