import javafx.application.Application;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage primaryStage) throws Exception {
        Button b1 = new Button("Button");
        Button b2 = new Button("Long Button");

        Parent root = new Parent() {
            {
               getChildren().addAll(b1, b2);
            }
            @Override
            protected void layoutChildren() {
                // layoutChildren sizes children by default.
                super.layoutChildren();
                
                double x = (getScene().getWidth() -
                                b1.getLayoutBounds().getWidth() -
                                b2.getLayoutBounds().getWidth()) / 2;
                double y = (getScene().getHeight() -
                                b1.getLayoutBounds().getHeight() -
                                b2.getLayoutBounds().getHeight()) / 2;
                b1.relocate(x, y);
                
                x += b1.getLayoutBounds().getWidth();
                b2.relocate(x, y);
            }
        };

        Scene scene = new Scene(root, 300, 200);
        primaryStage.setScene(scene);
        primaryStage.setTitle("Component's Intrinsic Size");
        primaryStage.show();
    }
}
