class My {
    // クラスフィールド変数sbを宣言および初期化
    private static final StringBuilder sb = new StringBuilder("012"); // privateから別のアクセス制御に変更しても以下は成り立つ

    // インスタンスフィールド変数の初期化子でsbを使用可能
    private final StringBuilder sb2 = sb;
    // (別の）クラスフィールド変数の初期化子でsbを使用可能
    private static final StringBuilder sb3 = sb;

    // コンストラクタ内でsbを使用可能
    My() {
        System.out.println(sb);
    }
    // 初期化ブロック内でsbを使用可能
    {
        System.out.println(sb);
    }
    // static初期化ブロック内でsbを使用可能
    static {
        System.out.println(sb);
    }

    // インスタンスメソッド内でsbを使用可能
    void exec() {
        System.out.println(sb);
    }
    // クラスメソッド内でsbを使用可能
    static void s_exec() {
        System.out.println(sb);
    }
}
