class My {
    // インスタンスフィールド変数の初期化子で呼び出し可能
    private final int i = exec();
    // クラスフィールド変数の初期化子で呼び出し可能
    private static final int i2 = exec();

    // インスタンスメソッド内で呼び出し可能
    void callExec() {
        exec();
    }
    // (別の)クラスメソッド内で呼び出し可能
    static void callExec2() {
        exec();
    }
    // コンストラクタ内で呼び出し可能
    My() {
        exec();
    }
    // 初期化ブロック内で呼び出し可能
    {
        exec();
    }
    // static初期化ブロック内で呼び出し可能
    static {
        exec();
    }

    // クラスメソッド宣言（クラス内で書く順序は無関係）
    private static int exec() { // privateから別のアクセス制御に変更しても上記は成り立つ
        return 1;
    }
}
