public class MyHost {
    // ネストしたクラス
    private static class MyHelper {
        private static final String nestedClassField = "nested private class field";
        private final String nestedInstanceField = "nested private instance field";

        private static void classMethod() {
            // エンクロージングオブジェクトのprivateクラスフィールドが可視
            System.out.println(MyHost.hostClassField);
            // System.out.println(hostClassField); // 非推奨（同名フィールドがMyHelperにあるとそちらを優先するので）
        }

        private void method(MyHost my) {
            // エンクロージングオブジェクトのprivateフィールドが可視
            System.out.println(my.hostInstanceField);
        }
    }

    private static final String hostClassField = "private class field";
    private final String hostInstanceField = "private instance field";

    private void exec() {
        // ネストクラスのオブジェクト生成
        MyHelper helper = new MyHelper();

        // MyHostとMyHelperでお互いのprivateインスタンスフィールドが可視
        System.out.println(helper.nestedInstanceField);
        helper.method(this);
    }

    public static void main(String... args) {
        // MyHostとMyHelperでお互いのprivateクラスフィールドが可視
        System.out.println(MyHelper.nestedClassField);
        MyHelper.classMethod();

        MyHost my = new MyHost();
        my.exec();
    }
}
