public class MyHostInner {
    // 内部クラス
    private class MyHelper {
        private final String nestedInstanceField = "nested private instance field";

        private final String sameNameField = "inner";

        private void method() {
            // 内部オブジェクトからエンクロージングオブジェクトのprivateフィールドが可視
            System.out.println(hostInstanceField);

            System.out.println(sameNameField); //=> "inner"
            System.out.println(this.sameNameField); //=> "inner"
            System.out.println(MyHostInner.this.sameNameField); //=> "outer"
        }
    }

    private final String hostInstanceField = "private instance field";
    private final String sameNameField = "outer";

    private void exec() {
        // 内部クラスのオブジェクト（内部オブジェクト）を生成
        MyHelper helper = new MyHelper();
        // エンクロージングオブジェクトから内部オブジェクトのprivateフィールドが可視
        System.out.println(helper.nestedInstanceField);
        helper.method();
    }

    public static void main(String... args) {
        // エンクロージングクラスのオブジェクト（エンクロージングオブジェクト）を生成
        MyHostInner my = new MyHostInner();
        my.exec();
    }
}
