import java.util.*;

public class Main {
    public static void main(String... args) {
        Map<String,String> map = new HashMap<>();
        map.put("ichi", "one");
        map.put("ni", "two");
        map.put("san", "three");

        // 拡張for構文による、キーに対する繰り返し処理
        for (String key : map.keySet()) {
            System.out.println(key);
        }
        // イテレータによる、キーに対する繰り返し処理
        for (Iterator<String> it = map.keySet().iterator(); it.hasNext(); ) {
            String key = it.next();
            System.out.println(key);
        }

        // 拡張for構文による、値に対する繰り返し処理
        for (String val : map.values()) {
            System.out.println(val);
        }

        // イテレータによる、値に対する繰り返し処理
        for (Iterator<String> it = map.values().iterator(); it.hasNext(); ) {
            String val = it.next();
            System.out.println(val);
        }

        // 拡張for構文による、キーと値に対する繰り返し処理
        for (Map.Entry<String,String> entry : map.entrySet()) {
            System.out.println(entry.getKey());
            System.out.println(entry.getValue());
        }

        // イテレータによる、キーと値に対する繰り返し処理
        for (Iterator<Map.Entry<String,String>> it = map.entrySet().iterator(); it.hasNext(); ) {
            Map.Entry<String,String> entry = it.next();
            System.out.println(entry.getKey());
            System.out.println(entry.getValue());
        }
    }
}
