public class Main {
    // メソッド参照を渡す側
    public static void main(String... args) {
        execPrinter(Main::printMessage, "foo"); // Main::printMessageがメソッド参照。"foo"はメソッドに渡す実引数
    }

    // メソッド参照を受け取る側
    static void execPrinter(Printer printer, String str) {
        printer.print(str);
    }

    // メソッド参照の参照先メソッド
    static void printMessage(String message) {
        System.out.println(message);
    }

    // 間をつなぐ魔法（後述）
    @FunctionalInterface // この1行はなくても良い（後述）
    interface Printer {
        public void print(String msg);
    }
}
