import java.util.Objects;
import java.util.function.*;

public class Main {
    public static void main(String... args) {
        // Functionは入力Tを受け取り出力Rを返す
        Function<String,StringBuilder> strToStrBldr = s -> new StringBuilder(s);
        /*
        // メソッド参照での書き換え（上記ラムダ式と同じ）
        Function<String,StringBuilder> strToStrBldr = StringBuilder::new;
        */

        // Predicateは入力Tを受け取り真偽値を返す
        Predicate<String> isValidString = s -> Objects.nonNull(s) && !s.isEmpty();

        // Consumerは入力Tを受け取り何か（一般的に副作用のある）処理をする（出力はない）
        Consumer<String> proc = s -> System.out.println(s);
        /*
        // メソッド参照で書き換え（上記ラムダ式と同じ）
        Consumer<String> proc = System.out::println;
        */

        // Supplierは入力なしで出力Tを返す
        Supplier<StringBuilder> factory = () -> new StringBuilder();
        /*
        // メソッド参照で書き換え（上記ラムダ式と同じ）
        Supplier<StringBuilder> factory = StringBuilder::new;
        */
    }
}