import java.util.function.*; // 以下のコード例ではimport文の記述を省略

public class Main {
    public static void main(String... args) {
        // StringBuilder::newはコンストラクタのメソッド参照
        IntFunction<StringBuilder> creator = StringBuilder::new;
        StringBuilder sb = creator.apply(8);
        // sb::appendはインスタンスメソッドのメソッド参照
        Function<String, StringBuilder> appender = sb::append;
        appender.apply("abc");
        // StringBuilder::appendはインスタンスメソッドのメソッド参照
        BiConsumer<StringBuilder, String> appender2 = StringBuilder::append;
        appender2.accept(sb, "def");
        System.out.println(sb); //=> "abcdef" を出力
    }
}
