import java.util.function.*;

public class Main {
    public static void main(String... args) {
        // 関数単体の定義
        Function<String,Integer> strLength = String::length; // 文字列長を返す関数
        Function<Integer,String> itoHex = i -> Integer.toString(i, 16); // 数値を16進数文字列にする関数
        Function<Integer,Integer> inc = n -> n + 1; // インクリメントする関数

        // 2つの関数を合成
        Function<String,String> newFn = strLength.andThen(itoHex);
        System.out.println(newFn.apply("0123456789")); //=> "0123456789"の文字列長10を16進数文字列にして "a" を出力

        // 3つ以上の関数合成も可能
        Function<Integer,Integer> inc3 = inc.andThen(inc).andThen(inc);
        System.out.println(inc3.apply(10)); //=> インクリメント3回で "13" を出力
    }
}