import java.util.function.*;

public class Main {
    public static void main(String... args) {
        // (a,b,c) -> (a + b) * c の3引数関数
        Function<Integer,Function<Integer,Function<Integer,Integer>>> fn3arg = a -> b -> c -> (a + b) * c;

        // fn3argの呼び出しコード
        fn3arg.apply(3).apply(2).apply(100); //=> (3 + 2) * 100 = 500

        /*
        // 2引数aとbを受け取り a + b を返す関数型インターフェース
        // (a, b) -> a + b
        Function<Integer,Function<Integer,Integer>> fnPlus = a -> b -> a + b;

        // (a,b) -> a * b の2引数関数
        Function<Integer,Function<Integer,Integer>> fnMulti = a -> b -> a * b;

        // リスト8.20のfnPlusとfnMultiを使ってfn3argを書き換えたコード
        fn3arg = a -> fnPlus.apply(a).andThen(fnMulti);
        */
    }
}
