import java.util.function.*;

public class Main {
    // 引数でConsumer<T>型のラムダ式またはメソッド参照を受け取る
    public static <T> long elapsedTime(Consumer<T> proc, T arg) {
        long start = System.nanoTime();
        proc.accept(arg);  // メソッドを実行
        return System.nanoTime() - start; // 実行時間（ナノ秒単位）を返す
    }

    public static void main(String... args) {
        // 利用側コード
        long elapsed = elapsedTime(s -> {}, "abc"); // 第1引数（s -> {}）はラムダ式
    }
}
