import java.util.*;
import java.util.stream.*;
import java.util.function.*;

public class Main {
    public static void main(String... args) {
        List<String> list = Arrays.asList("abc", "xyz", "defghi", "a");

        // コレクションをデータソースとしてストリーム生成
        Stream<String> stream1 = list.stream();
        // ストリームの中間フィルター処理（"a"を含む文字列として"abc"と"a"だけが通る）
        Stream<String> stream2 = stream1.filter(s -> s.contains("a")); // 引数はラムダ式
        // ストリームの中間マップ処理（大文字変換で"ABC"と"A"になる）
        Stream<String> stream3 = stream2.map(String::toUpperCase); // 引数はメソッド参照
        // ストリームの終端処理
        stream3.forEach(System.out::println); //=> "ABC"と"A"を表示
    }
}
