import java.util.function.*;
import java.util.stream.*;

public class Main {
    public static void main(String... args) {
        // 可変長引数のofメソッド（簡易なテストコードで便利）
        Stream<String> stream = Stream.of("abc", "xyz", "defghi", "a");

        /*
        // 無限に文字列を生成するストリーム
        Stream<String> stream = Stream.generate(() -> "foo");
        */

        /*
        // "0"から始まり数値をインクリメントした文字列を要素とする無限ストリーム
        // 数値要素のストリームは後述するIntStreamのほうが便利
        Stream<String> stream = Stream.iterate("0", s -> { int n = Integer.parseInt(s);
                                                           n++;
                                                           return String.valueOf(n); });
        */

        // 無限ストリームの利用には、途中で打ち切る中間処理（limitなど）が必須
        stream.limit(5).forEach(System.out::println);
    }
}
