import java.util.*;
import java.util.function.*;
import java.util.stream.*;

public class Main {
    public static void main(String... args) {
        Stream<String> stream = Stream.of("abc", "xyz", "defghi", "a");

        // StreamからListオブジェクトを生成
        List<String> list = stream.collect(Collectors.toList());
        /*
          または
          List<String> list = stream.collect(Collectors.toCollection(ArrayList::new));
        */

        // StreamからSetオブジェクトを生成
        Set<String> set = list.stream().collect(Collectors.toSet());

        // StreamからMapオブジェクトを生成（マップのキーと値への変換関数を指定。下記例のFunction.identity()は入力値をそのまま出力値にします）
        Map<String,String> map = list.stream().collect(Collectors.toMap(Function.identity(), Function.identity()));

        // Streamから配列を生成
        String[] arr = list.stream().toArray(String[]::new);
    }
}
