import java.util.*;
import java.util.function.*;
import java.util.stream.*;

public class Main {
    /**
     * 要素型Sのコレクションと要素型Tのコレクションを入力として
     * それぞれの要素をキーと値にしたMap<S,T>を生成
     * 注意: parallelStreamにすると動きません
     */
    static <S,T> Map<S,T> zip(Collection<S> c1, Collection<T> c2) {
        Iterator<T> it = c2.iterator();
        return c1.stream().filter(x -> it.hasNext())
                          .collect(() -> new HashMap<S,T>(),
                                   (map, s) -> map.put(s, it.next()), // S型のキーとT型の値
                                   (left, right) -> left.putAll(right));
    }

    public static void main(String... args) {
        Map<String,Integer> map = zip(Arrays.asList("one", "two"), Arrays.asList(1, 2));
        System.out.println(map);
    }
}
