import java.util.*;
import java.util.function.*;
import java.util.stream.*;

public class Main {
    public static void main(String... args) {
        // データソースのListオブジェクト
        List<String> list = Arrays.asList("ab", "c", "def");

        // 文字列連結
        String s = list.stream().collect(Collectors.joining(",", "[", "]")); //=> "[ab,c,def]"

        // カウント処理
        long count = list.stream().collect(Collectors.counting()); //=> 3

        // 最小値の検索
        list.stream().collect(Collectors.minBy(String::compareTo)).ifPresent(System.out::println); //=> "ab"を出力

        // マップ中間処理とcollect処理（リスト8.37の別解）
        List<Integer> result = list.stream().collect(Collectors.mapping(String::length, Collectors.toList()));

        // collect処理の後処理
        List<String> fronzenList = list.stream().collect(Collectors.collectingAndThen(Collectors.toList(), Collections::unmodifiableList));
        int joinLength = list.stream().collect(Collectors.collectingAndThen(Collectors.joining(",", "[", "]"), String::length)); //=> 10
    }
}
