import java.util.*;
import java.util.function.*;
import java.util.stream.*;

public class Main {
    // 分割後Mapのキー
    enum EvenOdd {
        Even, Odd,
    };
    
    public static void main(String... args) {
        // 数値群ストリーム
        Stream<Integer> nums = IntStream.rangeClosed(0, 9).boxed(); // 0から9までの数値群

        // 分割基準は2で割りきれるかどうか
        // groupingByの引数ラムダ式の返り値が結果Mapのキー
        Map<EvenOdd, List<Integer>> result = nums
            .collect(Collectors.groupingBy(n -> n % 2 == 0 ? EvenOdd.Even: EvenOdd.Odd));
        System.out.println(result); //=> "{Even=[0, 2, 4, 6, 8], Odd=[1, 3, 5, 7, 9]}" を出力
    }
}
