import java.util.*; // 以下のコード例ではimport文の記述を省略

public class Main {
    // コンストラクタのメソッド参照のための関数型インターフェース
    @FunctionalInterface
    interface Creator<E> {
        public E createInSAM(int capacity);
    }

    // インスタンスメソッドのメソッド参照のための関数型インターフェース
    @FunctionalInterface
    interface Appender {
        public StringBuilder appendInSAM(String str);
    }

    // インスタンスメソッドのメソッド参照のための関数型インターフェース
    // （レシーバオブジェクトを引数で受ける形式）
    @FunctionalInterface
    interface Appender2 {
        public void appendInSAM2(StringBuilder sb, String s);
    }

    public static void main(String... args) {
        Creator<StringBuilder> creator = StringBuilder::new; // コンストラクタのメソッド参照の代入
        StringBuilder sb = creator.createInSAM(8); // (概念上は)コンストラクタ呼び出し

        Appender appender = sb::append; // StringBuilderオブジェクトのappendメソッドの参照を代入
        appender.appendInSAM("abc");    // (概念上は)appendメソッド呼び出し

        Appender2 appender2 = StringBuilder::append; // メソッド参照の代入（第1引数がレシーバオブジェクト）
        appender2.appendInSAM2(sb, "def"); // (概念上は)appendメソッド呼び出し

        System.out.println(sb); //=> "abcdef" を出力
    }
}
