import java.util.*;
import java.util.function.*;
import java.util.stream.*;

public class Main {
    // 分割後Mapのキー
    enum EvenOdd {
        Even, Odd,
    };

    public static void main(String... args) {
        // 数値群ストリーム
        Stream<Integer> nums = IntStream.rangeClosed(0, 9).boxed(); // 0から9までの数値群

        // 分割基準は2で割りきれるかどうか
        // groupingByの第2引数のdownstream関数が、リスト8.40の結果Mapの値のListに対するcollect処理
        Map<EvenOdd, Long> result = nums.collect(Collectors.groupingBy(n -> n % 2 == 0 ? EvenOdd.Even: EvenOdd.Odd,
                                                                       Collectors.counting()));
        System.out.println(result); //=> "{Even=5, Odd=5}" を出力
    }
}
