import java.util.function.Consumer;

public class Main {
    private final String value;
    Main(String value) {
        this.value = value;
    }

    void exec() {
        // 下記2つのラムダ式はインスタンスメソッド相当
        Consumer<String> proc = s -> System.out.println(s + ": " + this.value); // このラムダ式の中ではthis参照を使える
        /*
        または
        Consumer<String> proc = s -> System.out.println(s + ": " + value); // thisは省略可能なのでこう書いても同じ
        */
        proc.accept("showing"); // ラムダ式の本体実行
    }

    public static void main(String... args) {
        // 下記ラムダ式はクラスメソッド相当
        Consumer<String> proc = s -> System.out.println(s); // このラムダ式の中ではthis参照を使えない

        Main my1 = new Main("my1-value"); // レシーバオブジェクト1
        my1.exec(); //=> "showing: my1-value" を出力
        Main my2 = new Main("my2-value"); // レシーバオブジェクト2
        my2.exec(); //=> "showing: my2-value" を出力
    }
}
